Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_default/waeup_edit.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_default/waeup_edit.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_default/waeup_edit.py	(revision 1596)
@@ -17,4 +17,10 @@
 from Products.CPSDocument.utils import getFormUidUrlArg
 
+import logging
+logger = logging.getLogger('Skins.waeup_edit')
+
+mtool = context.portal_membership
+member = mtool.getAuthenticatedMember()
+
 # Check flexible controls
 #context.editLayouts(REQUEST=REQUEST)
@@ -25,5 +31,5 @@
 if context.portal_type == "StudentStudyCourse":
     if len(context.objectIds()) > 0:
-        psm = 'Edit of StudyCourse is only possible if there are no levels'
+        psm = 'Edit of StudentStudyCourse is only possible if there are no levels inside!'
         args = getFormUidUrlArg(REQUEST)
         args['portal_status_message'] = psm
@@ -58,4 +64,6 @@
                                                   department = c_path[-3],
                                                   )
+            logger.info('%s edited %s (%s) of %s' % (member,context.id,course,student_id))
+
     elif context.portal_type == "StudentApplication":
         entry_mode = ds.get('entry_mode')
@@ -64,4 +72,5 @@
                                               entry_mode = entry_mode,
                                              )
+        logger.info('%s edited %s of %s' % (member,context.id,student_id))
     elif context.portal_type == "StudentClearance":
         matric_no = ds.get('matric_no')
@@ -70,4 +79,5 @@
                                               matric_no = matric_no,
                                              )
+        logger.info('%s edited %s of %s' % (member,context.id,student_id))                                             
     elif context.portal_type in ("StudentPersonal",):
         name = "%(firstname)s %(middlename)s %(lastname)s" % ds
@@ -81,5 +91,5 @@
         #if ds.get('sex'):
         #    jamb_sex = 'F'
-        # originally imported data must be kept; app_doc should not be changed here  
+        # originally imported data must be kept; app_doc should not be changed here
         #app_doc.edit(mapping={'jamb_lastname': name,
         #                      'jamb_sex': jamb_sex
@@ -91,4 +101,5 @@
                                               sex = ds.get('sex'),
                                              )
+        logger.info('%s edited %s of %s' % (member,context.id,student_id))
     elif context.portal_type == "Course":
         dd = {}
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_epayment/approve_epayment.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_epayment/approve_epayment.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_epayment/approve_epayment.py	(revision 1596)
@@ -1,3 +1,3 @@
-## Script (Python) "epayment_cb"
+## Script (Python) "approve_epayment"
 ##bind container=container
 ##bind context=context
@@ -10,8 +10,7 @@
 # $Id: aprove_epayment.py 1425 2007-02-15 17:52:01Z joachim $
 """
-payment callback
 """
 import logging
-logger = logging.getLogger('EPayment.Approve')
+logger = logging.getLogger('Skins.approve_epayment')
 import DateTime
 if context.portal_membership.isAnonymousUser():
@@ -42,5 +41,5 @@
 if doc.type_description.startswith('School Fee'):
     wftool.doActionFor(student,'pay_school_fee')
-logger.info('"%s", "approved epayment for","%s""' % (member,student_id))
+logger.info('%s approves epayment for %s' % (member,student_id))
 wftool.doActionFor(context,'close')
 return request.RESPONSE.redirect("%s/waeup_document_view" % context.absolute_url())
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_epayment/epayment_cb.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_epayment/epayment_cb.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_epayment/epayment_cb.py	(revision 1596)
@@ -13,5 +13,5 @@
 """
 import logging
-logger = logging.getLogger('EPayment.CallBack')
+logger = logging.getLogger('Skins.epayment_cb')
 import DateTime
 if context.portal_membership.isAnonymousUser():
@@ -43,10 +43,10 @@
 if  resp == '00':
     wftool.doActionFor(student,'pay_school_fee')
-    logger.info('"%s", "received valid callback"' % student_id)
+    logger.info('%s received valid callback' % student_id)
 
 elif len(resp) < 3:
-    logger.info('"%s", "received no callback"' % student_id)
+    logger.info('%s received no callback' % student_id)
 else:
-    logger.info('"%s", "received unsuccessfull callback"' % student_id)
+    logger.info('%s received unsuccessfull callback' % student_id)
 wftool.doActionFor(context,'close')
 
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_epayment/getPaymentsFolderInfo.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_epayment/getPaymentsFolderInfo.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_epayment/getPaymentsFolderInfo.py	(revision 1596)
@@ -1,3 +1,3 @@
-## Script (Python) "getPaymentsInfo"
+## Script (Python) "getPaymentsFolderInfo"
 ##bind container=container
 ##bind context=context
@@ -12,6 +12,7 @@
 Info for the PaymentsFolder
 """
-import logging
-logger = logging.getLogger('EPayment.Info')
+#import logging
+#logger = logging.getLogger('Skins.getPaymentsFolderInfo')
+
 import DateTime
 request = context.REQUEST
@@ -57,5 +58,5 @@
         row['confirmed'] = 'unsuccessful'
     payments.append(row)
-    
+
 
 info['payments'] = payments
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_epayment/pay_by_sc.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_epayment/pay_by_sc.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_epayment/pay_by_sc.py	(revision 1596)
@@ -14,5 +14,5 @@
 import logging
 from urllib import urlencode
-logger = logging.getLogger('EPayment.PayBySC')
+logger = logging.getLogger('Skins.pay_by_sc')
 import DateTime
 
@@ -85,7 +85,7 @@
     wftool.doActionFor(payment,'close')
     wftool.doActionFor(student,'pay_school_fee')
-    logger.info('"%s", "paid school fee by scratch card"' % student_id)
+    logger.info('%s paid school fee by scratch card' % student_id)
 else:
-    logger.info('"%s", "repeatedly paid school fee by scratch card"' % student_id)
+    logger.info('%s repeatedly paid school fee by scratch card' % student_id)
 url = "%s/payments" % (student.absolute_url())
 request.RESPONSE.redirect(url)
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_epayment/pay_online.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_epayment/pay_online.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_epayment/pay_online.py	(revision 1596)
@@ -14,5 +14,5 @@
 from urllib import urlencode
 import logging
-logger = logging.getLogger('EPayment.PayOnline')
+logger = logging.getLogger('Skins.pay_online')
 import DateTime
 
@@ -91,5 +91,5 @@
 info['callback_url'] = "%s/payments/%s/epayment_cb" % (student.absolute_url(),p_id)
 
-logger.info('"%(student_id)s","%(type_description)s", "%(amount)s N"' % info)
+logger.info('%(student_id)s initiated online school fee payment' % info)
 payment_fields = (('x_SiteID','site_id'),
                   ('x_Redirect_url','callback_url'),
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_epayment/simulate_callback.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_epayment/simulate_callback.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_epayment/simulate_callback.py	(revision 1596)
@@ -5,9 +5,11 @@
 return html renderer + psm
 """
-import DateTime,logging
+import DateTime
 current = DateTime.DateTime()
 pr = context.portal_registration
-logger = logging.getLogger('EPayment.Simulate')
 validate = REQUEST.has_key("cpsdocument_edit_button")
+
+import logging
+logger = logging.getLogger('Skins.simulate_callback')
 
 args = {}
@@ -18,4 +20,8 @@
 args['x_ApprAmt'] = REQUEST.get('x_amt')
 
+
+student_id = context.getStudentId()
+logger.info('%s received simulated callback' % student_id)
+
 from urllib import urlencode
 #url = "%s/epayment_cb/?%s" % (context.absolute_url(),urlencode(args))
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_pins/disable_pins.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_pins/disable_pins.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_pins/disable_pins.py	(revision 1596)
@@ -15,5 +15,5 @@
 current = DateTime.DateTime().strftime("%d-%m-%y_%H_%M_%S")
 import logging
-logger = logging.getLogger('Pin.Disable')
+logger = logging.getLogger('Skins.disable_pins')
 
 request = REQUEST
@@ -39,4 +39,4 @@
             }
     pincat.modifyRecord(**dict)
-    logger.info('"%s","disabled pin","%s"' % (member,uid))
+    logger.info('%s disabled pin %s' % (member,uid))
 return request.RESPONSE.redirect("%s/campus/pins/search_pins" % context.portal_url())
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_pins/enable_pins.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_pins/enable_pins.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_pins/enable_pins.py	(revision 1596)
@@ -15,5 +15,5 @@
 current = DateTime.DateTime().strftime("%d-%m-%y_%H_%M_%S")
 import logging
-logger = logging.getLogger('Pin.Enable')
+logger = logging.getLogger('Skins.enable_pins')
 
 request = REQUEST
@@ -42,4 +42,4 @@
             }
     pincat.modifyRecord(**dict)
-    logger.info('"%s","enabled pin","%s"' % (member,pid))
+    logger.info('%s enabled pin %s' % (member,uid))
 return request.RESPONSE.redirect("%s/campus/pins/search_pins" % context.portal_url())
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/add_course_result.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/add_course_result.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/add_course_result.py	(revision 1596)
@@ -12,4 +12,8 @@
 add a StudentCourseResult object
 """
+
+import logging
+logger = logging.getLogger('Skins.add_course_result')
+
 from urllib import urlencode
 try:
@@ -23,4 +27,9 @@
 aq_portal = context.portal_catalog.evalAdvancedQuery
 course_id = request.get('course_id')
+
+mtool = context.portal_membership
+member = mtool.getAuthenticatedMember()
+
+
 d = context.getCourseInfo(course_id)
 args = {}
@@ -28,11 +37,14 @@
 while True:
     if d['title'] == 'unknown':
-        err = "No such course"
+        err = "No such course!"
+        logger.info('%s tried to add StudentCourseResult object %s for non-existing course' % (member,course_id))
         break
     if context.hasObject(course_id):
-        err = "Course already exists"
+        err = "Course already exists!"
+        logger.info('%s tried to add StudentCourseResult object %s which is already in course list' % (member,course_id))
         break
     if context.hasObject("%s_co" % course_id):
-        err = "Course already exists as carryover course"
+        err = "Course already exists as carryover course!"
+        logger.info('%s tried to add StudentCourseResult object %s which already exists as carryover course' % (member,course_id))
         break
     break
@@ -40,7 +52,10 @@
 if err:
     args['course_id'] = course_id
-    args['error'] = err
+    #args['error'] = err
+    args['portal_status_message'] = err
     url = "%s?%s" % (context.absolute_url(),urlencode(args))
     return request.RESPONSE.redirect(url)
+
+   
 cr_id = context.invokeFactory('StudentCourseResult',course_id)
 #set_trace()
@@ -50,4 +65,7 @@
 context.portal_workflow.doActionFor(cr,'close')
 args['course_id'] = course_id
+
+logger.info('%s added StudentCourseResult object %s' % (member,course_id))   
+
 from urllib import urlencode
 url = "%s?%s" % (context.absolute_url(),urlencode(args))
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/add_student.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/add_student.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/add_student.py	(revision 1596)
@@ -13,5 +13,5 @@
 acco_cat = context.portal_accommodation
 import logging
-logger = logging.getLogger('Student.Add')
+logger = logging.getLogger('Skins.add_student')
 
 validate = REQUEST.has_key("cpsdocument_edit_button") and\
@@ -67,5 +67,5 @@
 student_rec = context.getFormattedStudentEntry(context.students_catalog(id = sid)[0])
 psm = "Student record with Id %s and Password %s has been created." % (sid,password)
-logger.info('"%s","created student","%s"' % (member,sid))
+logger.info('%s created student %s' % (member,sid))
 return context.add_student_form(rendered = rendered,
                                  #psm = "%s, %s" % (psm,ds),
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/application_edit.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/application_edit.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/application_edit.py	(revision 1596)
@@ -16,5 +16,5 @@
 current = DateTime.DateTime()
 import logging
-logger = logging.getLogger('Student.Application.Edit')
+logger = logging.getLogger('Skins.application_edit')
 
 # Until ajax posts directly to its own script...
@@ -30,5 +30,5 @@
 
 if info is None:
-    logger.info('"anonymous access","%s"' % REQUEST.get('URL0'))
+    logger.info('Anonymous user tried to access %s"' % REQUEST.get('URL0'))
     return REQUEST.RESPONSE.redirect("%s/srp_anonymous_view" % context.portal_url())
 
@@ -56,5 +56,5 @@
     elif cpsdocument_edit_and_view_button:
         if 1: ## app_doc.passport is not None:
-            logger.info('"%s", "proceeded to start clearance"' % (info['id']))
+            logger.info('%s proceeded to start clearance' % (info['id']))
             action = "/start_clearance"
             base_url = student.absolute_url()
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/change_password.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/change_password.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/change_password.py	(revision 1596)
@@ -14,5 +14,5 @@
 current = DateTime.DateTime()
 #pr = context.portal_registration
-logger = logging.getLogger('Student.change_password')
+logger = logging.getLogger('Skins.change_password')
 validate = request.has_key("change_password")
 students_dir = context.portal_directories.students
@@ -24,5 +24,5 @@
 requested_id = context.getStudentId()
 if requested_id and not context.isStaff() and member_id != requested_id:
-    logger.info('"%s", "tried to access", "%s"' % (member_id,requested_id))
+    logger.info('%s tried to access %s' % (member_id,requested_id))
     return None
 elif context.isStaff():
@@ -74,4 +74,5 @@
 args['__ac_name'] = student_id
 args['__ac_password'] = password
+logger.info('%s changed password from %s to %s' % (member_id,old_password,password))
 from urllib import urlencode
 url = "%s/logged_in?%s" % (context.absolute_url(),urlencode(args))
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/clearance_edit.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/clearance_edit.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/clearance_edit.py	(revision 1596)
@@ -16,5 +16,5 @@
 current = DateTime.DateTime()
 import logging
-logger = logging.getLogger('Student.Clearance.Edit')
+logger = logging.getLogger('Skins.clearance_edit')
 request = REQUEST
 
@@ -70,5 +70,5 @@
     if cpsdocument_edit_button or result_edit_button:
         psm = "Content changed!"
-        logger.info('"%s","edited clearance of","%s"' % (member_id,student_id ))
+        logger.info('%s edited clearance of %s' % (member_id,student_id ))
         if clear_doc.clr_ac_pin == "":
             res = context.portal_pins(student=member_id)
@@ -92,8 +92,8 @@
                     missing = True
             if missing:
-                logger.info('"%s","requested clearance with documents missing"' % (student_id))
+                logger.info('%s requested clearance with documents missing' % (student_id))
                 psm = "You have not uploaded all necessary documents to request clearance!"
             else:
-                logger.info('"%s","requested clearance"' % (student_id))
+                logger.info('%s requested clearance' % (student_id))
                 info['clear_doc'].edit(mapping = {'request_date': current,})
                 wftool.doActionFor(info['clear'],'close')
@@ -103,10 +103,10 @@
                     action = "/clearance_view"
         elif acknowledge and info['review_state'] != "clearance_pin_entered":
-            logger.info('"%s","repeatedly requested clearance"' % (student_id))
+            logger.info('%s repeatedly requested clearance' % (student_id))
             psm = "You have already requested clearance!"
         else:
             psm = "You must tick the acknowledgement check box before submission!"
     elif clear_and_validate_button and info['review_state'] == "clearance_requested":
-        logger.info('"%s","cleared","%s"' % (member_id,student_id ))
+        logger.info('%s cleared %s' % (member_id,student_id ))
         #from Products.zdb import set_trace
         #set_trace()
@@ -117,9 +117,12 @@
         psm = "This student is already cleared!"
     elif reject_clearance_button:
-        logger.info('"%s","rejected clearance for","%s"' % (member_id,student_id ))
+        logger.info('%s rejected clearance for %s' % (member_id,student_id ))
         wftool.doActionFor(info['clear'],'open')
         wftool.doActionFor(info['student'],'reject_clearance')
         action = "/contact_student_form"
         psm = "Student's clearance request has been rejected! Please fill and submit the form below!"
+        subject = "Clearance request rejected"
+        args['subject'] = subject
+        args['continue'] = 'external_clearance_edit_form'
 else:
     psm = "Please correct your errors!"
@@ -128,4 +131,4 @@
 args['portal_status_message'] = psm
 url = clear.absolute_url() + action + '?' + urlencode(args)
-REQUEST.RESPONSE.redirect(url)
+return REQUEST.RESPONSE.redirect(url)
 
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/clearance_slip.pt
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/clearance_slip.pt	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/clearance_slip.pt	(revision 1596)
@@ -1,5 +1,5 @@
-<metal:html tal:define="info context/getClearanceInfo">
-  <metal:body use-macro="here/main_template/macros/master">
-    <metal:main fill-slot="main">
+<metal:body use-macro="here/main_template/macros/master">
+    <metal:main fill-slot="main"
+                 tal:define="info context/getClearanceInfo">
       <span tal:condition="not: info">
         <span tal:content="here/illegal_view" />
@@ -66,4 +66,3 @@
       </span>
     </metal:main>
-  </metal:body>
-</metal:html>
+</metal:body>
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/contact_student_form.pt
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/contact_student_form.pt	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/contact_student_form.pt	(revision 1596)
@@ -1,6 +1,9 @@
+<metal:block define-macro="contact_student_form">
 <metal:body use-macro="here/main_template/macros/master">
     <metal:main fill-slot="main"
                 tal:define="member python:context.portal_membership.getAuthenticatedMember();
                         info context/getStudentBaseInfo;
+                        subject python:context.REQUEST.get('subject');
+                        continue python:context.REQUEST.get('continue')
                         ">
       <span tal:condition="not: info">
@@ -8,5 +11,5 @@
       </span>                        
     
-      <span tal:condition="info">
+      <span tal:condition="python: info and subject">
       <h3>Contact Student</h3>
       <br />
@@ -23,5 +26,7 @@
       <input type="hidden" name="student_email" type="text" id="student_email"
              tal:attributes="value info/student/email"/>                   
-
+      <input type="hidden" name="probtype" type="text" id="probtype"
+             tal:attributes="value subject"/>     
+             
       <table width="100%" border="0" cellspacing="5" cellpadding="0">
         <tr>
@@ -42,11 +47,9 @@
         </tr>
         <tr>
-          <td>
-             <strong>Type of Rejection: </strong>
+          <td valign="top">
+             <strong>Reason of Notification: </strong>
           </td>
-          <td>
-              <select name="probtype" class="boxgreen" id="probtype">
-                <option>Clearance request rejected</option>
-              </select>        
+          <td valign="bottom">
+             <span tal:content="subject" />
           </td>
         </tr>        
@@ -67,5 +70,6 @@
       </span>
       <form action="." method="post" class="group">
-            <input type="submit" name="external_clearance_edit_form:method"
+            <input type="submit" name="."
+                       tal:attributes="name string:${continue}:method"
                        class="context" value="Continue" />
       </form>      
@@ -73,2 +77,3 @@
     </metal:main>
 </metal:body>
+</metal:block>
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/course_registration_slip.pt
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/course_registration_slip.pt	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/course_registration_slip.pt	(revision 1596)
@@ -1,12 +1,13 @@
-<metal:html tal:define="info context/getStudyLevelInfo;
+<metal:body use-macro="here/main_template/macros/master">
+    <metal:main fill-slot="main"
+                tal:define="info context/getStudyLevelInfo;
                   is_so context/isSectionOfficer;
                   is_ca info/is_ca;
                   show_check_boxes info/show_check_boxes;
-		  is_student info/is_student;
-		  status_info info/status_info;
-		  review_state info/review_state;
-		  view_only info/view_only">
-  <metal:body use-macro="here/main_template/macros/master">
-    <metal:main fill-slot="main">
+                  validated python:context.getStudentReviewState() in ('courses_validated',);
+		              is_student info/is_student;
+            		  status_info info/status_info;
+            		  review_state info/review_state;
+            		  view_only info/view_only">
       <span tal:condition="not: info">
         <span tal:content="here/illegal_view" />
@@ -14,29 +15,24 @@
       <span tal:condition="info">
       <h3>Course Registration Slip</h3>
+      
       <br />
-      <table width="" cellpadding="2" cellspacing="0">
+      
+      <div tal:condition="validated">
+        - validated by Course Adviser -
+      </div>
+      <div tal:condition="not: validated">
+        - not yet validated by Course Adviser -
+      </div>
+      
+      <br />
+      <span tal:omit-tag=""
+            tal:content="structure python: info['app_doc'].render(proxy=info['app_doc'],
+            layout_mode='view_info', 
+            layout_id='student_application_fe')" 
+            />           
+
+      <table  cellpadding="2" cellspacing="0">
           <tr>
-            <td valign="top"><span class="dlabel">Name</span>:
-            </td>
-            <td> 
-              <span tal:content="info/student/name" />
-            </td>      
-          </tr>
-          <tr>
-            <td valign="top"><span class="dlabel">Student Id</span>:
-            </td>
-            <td> 
-              <span tal:content="info/student/id" />
-            </td>      
-          </tr>
-          <tr>
-            <td valign="top"><span class="dlabel">Matriculation No</span>:
-            </td>
-            <td> 
-              <span tal:content="info/student/matric_no" />
-            </td>      
-          </tr>
-          <tr>
-            <td valign="top"><span class="dlabel">Faculty Id</span>:
+            <td valign="top" width="180px"><span class="dlabel">Faculty Id</span>:
             </td>
             <td> 
@@ -111,5 +107,4 @@
        </span>              
     </metal:main>
-  </metal:body>
-</metal:html>
+</metal:body>
   
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/create_level.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/create_level.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/create_level.py	(revision 1596)
@@ -21,5 +21,5 @@
 response = request.RESPONSE
 redirect = response.redirect
-logger = logging.getLogger('Student.create_level')
+logger = logging.getLogger('Skins.create_level')
 mtool = context.portal_membership
 member = mtool.getAuthenticatedMember()
@@ -30,8 +30,13 @@
 cert_id = student.course
 current_level = student.level
-in_progress =  session.get('in_progress','finished')
-if in_progress == 'finished':
+in_progress =  request.get('in_progress','not started')
+
+if context.hasObject(current_level):
+    response.redirect("%s/%s" % (context.absolute_url(),current_level))
+    return
+
+if in_progress in ('not started','started'):
     session.set('in_progress','started')
-    view = context.in_progress_view(refresh=3,page='%s/study_level_view' % current_level)
+    view = context.in_progress_view(refresh=3,page='create_level?in_progress=started')
     response.setHeader('Content-type','text/html; charset=ISO-8859-15')
     response.setHeader('Content-length','%d' % (len(view)))
@@ -39,12 +44,8 @@
     response.write(view)
     response.write('')
-elif in_progress == 'started':
-    return
+    if in_progress == 'started':
+        return
+    
 
-if context.hasObject(current_level):
-    return
-    level = getattr(context,current_level)
-    return response.redirect("%s" % level.absolute_url())
-    
 context.invokeFactory('StudentStudyLevel',"%s" % current_level)
 level = getattr(context,"%s" % current_level)
@@ -63,5 +64,5 @@
         c_res = aq_courses(query)
         if not c_res:
-            logger.info('"%s","%s course not found in courses catalog"' % (student.id,co.CosCode))
+            logger.info('%s", course %s not found in courses_catalog' % (student.id,co.CosCode))
             continue
         course_cat_entry = c_res[0]
@@ -73,9 +74,9 @@
                 score = int(co.Score)
             except:
-                logger.info('"%s"," course %s invalid score %s"' % (student.id,
+                logger.info('%s, course %s has invalid score %s"' % (student.id,
                                                                     co.CosCode,
                                                                     co.Score))
                 continue
-            if int(c_res[0].passmark) <= score:  
+            if int(c_res[0].passmark) <= score:
                 continue
             carry_over = True
@@ -105,4 +106,3 @@
         d['core_or_elective'] = getattr(c.getObject().getContent(),'core_or_elective')
         course_result.getContent().edit(mapping=d)
-session.set('in_progress','finished')
 return
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/delete_course_result.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/delete_course_result.py	(revision 1596)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/delete_course_result.py	(revision 1596)
@@ -0,0 +1,39 @@
+## Script (Python) "delete_course_result"
+##bind container=container
+##bind context=context
+##bind namespace=
+##bind script=script
+##bind subpath=traverse_subpath
+##parameters=ids=[], REQUEST=None
+##title=
+##
+# $Id: delete_course_result.py 1557 2007-03-15 16:00:27Z joachim $
+"""
+FIXME: add docstring.
+"""
+
+from Products.CMFCore.utils import getToolByName
+here = context
+
+import logging
+logger = logging.getLogger('Skins.delete_course_result')
+mtool = context.portal_membership
+member = mtool.getAuthenticatedMember()
+
+ret_url = here.absolute_url()
+
+message = ''
+if ids:
+    real_ids = []
+    for id in ids:
+        if context.hasObject(id):
+            real_ids.append(id)
+    if real_ids:
+        context.manage_delObjects(real_ids)
+        logger.info('%s deleted StudentCourseResult object %s' % (member,id))
+        message = 'portal_status_message=psm_item(s)_deleted'
+else:
+    message = 'portal_status_message=psm_select_at_least_one_document'
+
+if REQUEST is not None:
+    return REQUEST.RESPONSE.redirect(ret_url + '?' + message)
Index: /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/external_contact_student_form.pt
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/external_contact_student_form.pt	(revision 1596)
+++ /WAeUP_SRP/branches/joachim-event-branch/skins/waeup_student/external_contact_student_form.pt	(revision 1596)
@@ -0,0 +1,1 @@
+<metal:block use-macro="here/contact_student_form/macros/contact_student_form" />
